<?php
	function handleError($error, $description, $file, $line, $context)
	{
		switch($error)
		{
			case E_USER_ERROR:
				$type = "Error";
				$color = "red";
				break;
			case E_WARNING:
			case E_USER_WARNING:
				$type = "Warning";
				$color = "yellow";
				break;
			case E_NOTICE:
			case E_USER_NOTICE:
				$type = "Notice";
				$color = "blue";
				break;
			default:
				$type = "Other Error";
		}

		print("<table border=\"1\"><tr><td bgcolor=\"$color\">" .
			"$type: $description in $file on line $line " .
			"({$context["_SERVER"]["REMOTE_ADDR"]})<br>" .
			"</tr></td></table>");
	}

	//switch to our custom handler
	set_error_handler('handleError');
	trigger_error("Custom error handler", E_USER_WARNING);

	//show PHP's default handler
	restore_error_handler();
	trigger_error("PHP's default error handler", E_USER_WARNING);
?>