<?php
	$picture = "leonatkinson.png";

	//shows the effect of the filter
	function showPicture(&$image, $file, $title)
	{
		//write filter name into image
		$colorBlack = imagecolorallocate($image, 0, 0, 0);
		imagestring($image, 5, 10, 10, $title, $colorBlack);
		//write image to a file
		imagepng($image, $file);
		//clean up memory
		imagedestroy($image);
		//print image tag
		print("<img src=\"$file\">");
	}

	//Reduce Brightness
	$image = imagecreatefrompng($picture);
	imagefilter($image, IMG_FILTER_BRIGHTNESS, -128);
	showPicture($image, "brightness_$picture", "Brightness");

	//Colorize
	$image = imagecreatefrompng($picture);
	imagefilter($image, IMG_FILTER_COLORIZE, 100, 128, -64);
	showPicture($image, "colorize_$picture", "Colorize");

	//Increase contrast
	$image = imagecreatefrompng($picture);
	imagefilter($image, IMG_FILTER_CONTRAST, 60);
	showPicture($image, "contrast_$picture", "Contrast");

	//Edge
	$image = imagecreatefrompng($picture);
	$outputFile = "edge_$picture";
	imagefilter($image, IMG_FILTER_EDGEDETECT);
	showPicture($image, "edge_$picture", "Detect Edges");

	//Emboss
	$image = imagecreatefrompng($picture);
	imagefilter($image, IMG_FILTER_EMBOSS);
	showPicture($image, "emboss_$picture", "Emboss");

	//Blur
	$image = imagecreatefrompng($picture);
	imagefilter($image, IMG_FILTER_GAUSSIAN_BLUR);
	showPicture($image, "blur_$picture", "Gaussian Blur");

	//Convert to grayscale
	$image = imagecreatefrompng($picture);
	imagefilter($image, IMG_FILTER_GRAYSCALE);
	showPicture($image, "grayscale_$picture", "Grayscale");

	//Mean Removal
	$image = imagecreatefrompng($picture);
	imagefilter($image, IMG_FILTER_MEAN_REMOVAL);
	showPicture($image, "mean_$picture", "Mean Removal");

	//Get negative
	$image = imagecreatefrompng($picture);
	imagefilter($image, IMG_FILTER_NEGATE);
	showPicture($image, "negate_$picture", "Negative");

	//Selective blur
	$image = imagecreatefrompng($picture);
	imagefilter($image, IMG_FILTER_SELECTIVE_BLUR);
	showPicture($image, "selective_$picture", "Selective blur");

	//Smooth
	$image = imagecreatefrompng($picture);
	imagefilter($image, IMG_FILTER_SMOOTH, 123);
	showPicture($image, "smooth_$picture", "Smooth");
?>