<?php
	//set parameters for text
	$font_file = "/usr/share/fonts/default/Type1/n019003l.pfb";
	$size = 20;
	$angle = 0;
	$text = "PHP";
	$antialias_steps = 16;
	$spacing = 0;
	$leading = 0;

	//create red square
	$image = imagecreate(100, $size*3);
	$colorYellow = imagecolorallocate($image, 0xFF, 0xFF, 0xCC);
	$colorBlack = imagecolorallocate($image, 0, 0, 0);
	imagefill($image, 10, 10, $colorYellow);

	//Load font
	if(!($myFont = imagepsloadfont($font_file)))
	{
		print("Unable to load font!");
		exit();
	}

	//write normal text
	imagepstext($image, $text, $myFont, $size,
	$colorBlack, $colorYellow,
	0, $size-1, $spacing, $leading,
	$angle, $antialias_steps);

	//make extended font
	$myFontExtended = imagepsloadfont($font_file);
	imagepsextendfont($myFontExtended, 1.5);

	//write extended text
	imagepstext($image, $text, $myFontExtended, $size,
	$colorBlack, $colorYellow,
	0, ($size*2)-1, $spacing, $leading,
	$angle, $antialias_steps);

	//make slanted font
	$myFontSlanted = imagepsloadfont($font_file);
	imagepsslantfont($myFontSlanted, 1.5);

	//write slanted text
	imagepstext($image, $text, $myFontSlanted, $size,
	$colorBlack, $colorYellow,
	0, ($size*3)-1, $spacing, $leading,
	$angle, $antialias_steps);

	//unload fonts
	imagepsfreefont($myFont);
	imagepsfreefont($myFontExtended);
	imagepsfreefont($myFontSlanted);

	//send image
	header("Content-type: image/png");
	imagepng($image);
?>