<?php
	/*
	** Draw text over a photograph using a PostScript font
	*/

	//set parameters for text
	$image = "waterfall.jpg";
	$font_file = "/usr/share/fonts/default/Type1/n019003l.pfb";
	$size = 100;
	$angle = 0;
	$text = "Waterfall";
	$antialias_steps = 16;
	$spacing = 0;
	$leading = 0;

	//Load font
	if(!($myFont = imagepsloadfont($font_file)))
	{
		print("Unable to load font!");
		exit();
	}

	//get bounding box
	$Box = imagepsbbox($text, $myFont, $size, $spacing, $leading,
	$angle);

	//load photograph
	$image = imagecreatefromjpeg($image);

	//set up text color
	$colorText = imagecolorallocate($image, 0x00, 0xFF, 0x00);
	$colorClearText = imagecolorresolvealpha($image, 0x00, 0xFF,
		0x00, 0xFF);
	$colorShadow = imagecolorresolvealpha($image, 0x00, 0x00,
		0x00, 0x50);
	$colorClearShadow = imagecolorresolvealpha($image, 0x00, 0x00,
		0x00, 0xFF);
	imagelayereffect($image, IMG_EFFECT_NORMAL);

	//make soft drop shadow
	imagepstext($image, $text, $myFont, $size,
		$colorShadow, $colorClearShadow,
		55, $Box[3]+55, $spacing, $leading,
		$angle, $antialias_steps);

	//write the text
	imagepstext($image, $text, $myFont, $size,
		$colorText, $colorClearText,
		50, $Box[3]+50, $spacing, $leading,
		$angle, $antialias_steps);

	//unload font
	imagepsfreefont($myFont);

	//send image
	header("Content-type: image/png");
	imagepng($image);
?>