<?php
	$image = imagecreatetruecolor(200,200);
	$colorYellow = imagecolorresolve($image, 255, 255, 128);
	imagefill($image, 0, 0, $colorYellow);

	//load a tile
	$tile = imagecreatefromjpeg("woodtile.jpg");
	imagesettile($image, $tile);

	//set up three points of the triangle
	$points = array(100, 10, 10, 190, 190, 190);

	//draw triangle
	imagefilledpolygon($image,
		$points, count($points)/2,
		IMG_COLOR_TILED);

	//create a grid tile
	$grid = imagecreate(32, 32);
	$gridColorBlack = imagecolorallocate($grid, 0x00, 0x00, 0x00);
	$gridColorTransparent = imagecolorallocate($grid,
		0xFF, 0x00, 0xFF);
	imagecolortransparent($grid, $gridColorTransparent);
	imagefill($grid, 0, 0, $gridColorTransparent);
	imagesetthickness($grid, 5);
	imageline($grid, 0, 0, 31, 0, $gridColorBlack);
	imageline($grid, 0, 0, 0, 31, $gridColorBlack);
	imagesettile($image, $grid);

	//paint grid over entire image
	imagefilledrectangle($image, 0, 0, 199, 199, IMG_COLOR_TILED);

	//send image
	header("Content-type: image/png");
	imagepng($image);
?>