<?php
	//attempt to open image, suppress error messages
	if(!($image = @imagecreatefrompng("leonatkinson.png")))
	{
		//error, so create an error image and exit
		$image = imagecreate(200,200);
		$colorWhite = imagecolorallocate($image, 255, 255, 255);
		$colorBlack = imagecolorallocate($image, 0, 0, 0);
		imagefill($image, 0, 0, $colorWhite);
		imagestring($image, 4, 10, 10, "Couldn't load image!",
			$colorBlack);
		header("Content-type: image/png");
		imagepng($image);
		exit();
	}

	//get RGB value of color at (50,50)
	$rgb = imagecolorat($image, 50, 50);
	$rgb = strtoupper(
		dechex(($rgb >> 0xF) & 0xFF) .
		dechex(($rgb >> 0x8) & 0xFF) .
		dechex($rgb & 0xFF));

	//write the RGB value into image
	$colorBlack = imagecolorallocate($image, 0, 0, 0);;
	imagestring($image, 5, 10, 10, "#$rgb", $colorBlack);

	//switch to palette mode
	imagetruecolortopalette($image, FALSE, 16);

	//get index of the color at (50,50)
	$colorIndex = imagecolorat($image, 50, 50);

	//change that color to red
	imagecolorset($image, $colorIndex, 255, 0, 0);

	//send image
	header("Content-type: image/png");
	imagepng($image);
?>