<?php
	/*
	** Compare closest color to real color
	*/

	//attempt to open image, suppress error messages
	if(!($image = @imagecreatefromjpeg("waterfall.jpg")))
	{
		//error, so create an error image and exit
		$image = imagecreate(200,200);
		$colorWhite = imagecolorallocate($image, 255, 255, 255);
		$colorBlack = imagecolorallocate($image, 0, 0, 0);
		imagefill($image, 0, 0, $colorWhite);
		imagestring($image, 4, 10, 10, "Couldn't load image!",
			$colorBlack);
		header("Content-type: image/png");
		imagepng($image);
		exit();
	}

	//convert true color to 128 color palette
	imagetruecolortopalette($image, FALSE, 128);

	//move up to a 256 color palette
	//so we have room for allocation
	imagetruecolortopalette($image, FALSE, 256);

	//find index of color closest to pure green
	$closestColor = imagecolorclosest($image, 0, 255, 0);

	//draw block of color
	imagefilledrectangle($image, 0, 0, 199, 99, $closestColor);

	//allocate inverse so we can print RGB values
	$rgb = imagecolorsforindex($image, $closestColor);
	$inverseColor = imagecolorallocate($image,
		~$rgb['red'], ~$rgb['green'], ~$rgb['blue']);
	imagestring($image, 4, 10, 10,
		"{$rgb['red']}, {$rgb['green']}, {$rgb['blue']}",
		$inverseColor);

	//try to get exactly pure green
	$exactColor = imagecolorexact($image, 0, 255, 0);
	if($exactColor == -1)
	{
		//if not found, use black
		$exactColor = imagecolorallocate($image, 0, 0, 0);
	}

	//draw block of color
	imagefilledrectangle($image, 0, 100, 199, 199, $exactColor);

	//if pure green doesn't exist, allocate it
	$resolveColor = imagecolorresolve($image, 0, 255, 0);

	//draw block of color
	imagefilledrectangle($image, 0, 200, 199, 299, $resolveColor);

	//send image
	header("Content-type: image/png");
	imagepng($image);
?>