<?php
	//set-up data to insert
	$NewEmployee = array(
		array(8001, 'Smith', 'Clerk', 30),
		array(8002, 'Jones', 'Analyst', 20),
		array(8003, 'Atkinson', 'President', 40)
		);

	//connect to database
	$Link = ocilogon("scott", "tiger");

	//assemble query
	$Query = "INSERT INTO emp " . "(EMPNO, ENAME, JOB, HIREDATE, DEPTNO) " . 
		"VALUES (:empno, :ename, :job, SYSDATE, :deptno ) ";
	$Statement = ociparse($Link, $Query);

	//create descriptor the abstract data type
	$RowID = ocinewdescriptor($Link, OCI_D_ROWID);

	//bind input and output variables
	ocibindbyname($Statement, ":empno", $EmployeeNumber, 32);
	ocibindbyname($Statement, ":ename", $EmployeeName, 32);
	ocibindbyname($Statement, ":job", $Job, 32);
	ocibindbyname($Statement, ":deptno", $DeptNo, 32);

	//loop over each new employee
	foreach($NewEmployee as $e)
	{
		//set column values
		$EmployeeNumber = $e[0];
		$EmployeeName = $e[1];
		$Job = $e[2];
		$DeptNo = $e[3];

		//execute query, do not automatically commit
		ociexecute($Statement, OCI_DEFAULT);
	}

	//free the statement
	//ocifreestatement($Statement);
	//assemble query for getting contents
	$Query = "SELECT EmpNo, EName, Job, HireDate, DName " .
		"FROM emp JOIN dept ON (emp.DeptNo = dept.DeptNo)";

	//parse query
	$Statement = ociparse($Link, $Query);

	//execute query, make sure keep autocommit off
	ociexecute($Statement, OCI_DEFAULT);

	//fetch each row
	while(ocifetchinto($Statement, $Columns,
	OCI_NUM | OCI_RETURN_NULLS | OCI_RETURN_LOBS))
	{
		print(implode(",", $Columns) . "<br>\n");
	}

	//free the statement
	ocifreestatement($Statement);

	//undo the inserts
	//Normally, you won't do this, if we undo the inserts
	//each time, we can run the example over and over
	ocirollback($Link);

	//close connection
	ocilogoff($Link);
?>