<?php
	//setup distinguished name
	$dn = array(
		"countryName"=>"US",
		"stateOrProvinceName"=>"California",
		"organizationName"=>"Example Company, Inc.",
		"commonName"=>"example.com",
		"emailAddress"=>"leon@example.com");

	//setup configuration
	$config = array(
		'private_key_bits'=>1024);

	//make new key
	$privatekey = openssl_pkey_new();
	openssl_pkey_export_to_file($privatekey, 'example.pem',
		'corephp');

	//make certificate signing request
	$csr = openssl_csr_new($dn, $privatekey, $config);
	openssl_csr_export_to_file($csr, 'example.csr', FALSE);

	//make self-signed certificate
	$certificate = openssl_csr_sign($csr, NULL, $privatekey, 45);
	openssl_x509_export_to_file($certificate, 'example.crt');
?>