<?php
	class EmployeeTracker
	{
		static $title = array(
			"President"=>1,
			"Executive"=>2,
			"Manager"=>3,
			"Programmer"=>4
			);

		public $employees;

		public function __construct($data)
		{
			$this->employees = $data;
		}

		// byName
		// compare employees based on name
		function byName($left, $right)
		{
			return(strcmp($left[0], $right[0]));
		}

		// byTitle
		// compare employees based on title
		function byTitle($left, $right)
		{
			if($left[1] == $right[1])
			{
				return(0);
			}
			else
			{
				return(EmployeeTracker::$title[$left[1]] -
					EmployeeTracker::$title[$right[1]]);
				}
		}
	
		// bySalary
		// compare employees based on salary, then name
		function bySalary($left, $right)
		{
			if($left[2] == $right[2])
			{
				return(byName($left, $right));
			}
			else
			{
				return($right[2] - $left[2]);
			}
		}

		// printEmployees
		// send entire list of employees to browser
		function printEmployees()
		{
			foreach($this->employees as $value)
			{
				printf("%s (%s) %.2f/Hour <br>\n",
					$value[0],
					$value[1],
					$value[2]);
			}
		}
	}

	// Create some employees (Name, Title, Rate)
	$e = new EmployeeTracker(array(
	array("Mckillop, Jeff", "Executive", 50),
	array("Porter, Carl", "Manager", 45),
	array("Marazzani, Rick", "Manager", 35),
	array("Dibetta, Bob", "Programmer", 65),
	array("Atkinson, Leon", "President", 100)));

	print("<b>Unsorted</b><br>\n");
	$e->printEmployees();

	print("<B>Sorted by Name</B><br>\n");
	usort($e->employees, array($e, "byName"));
	$e->printEmployees();

	print("<b>Sorted by Title</b><br>\n");
	usort($e->employees, array($e, "byTitle"));
	$e->printEmployees();

	print("<b>Sorted by Rate</b><br>\n");
	usort($e->employees, array($e, "bySalary"));
	$e->printEmployees();
?>