<html>
<head>
<title>Listing 24-6</title>
</head>
<body>
<?php
	/*
	** Function: makeAttachment
	** Input: ARRAY attachment
	** Output: STRING
	** Description: Returns headers and data for one
	** attachment. It expects an array with elements
	** type, name, and content. Attachments are naively
	** base64 encoded, even when unnecessary.
	*/
	function makeAttachment($attachment)
	{
		//send content type
		$headers = "Content-Type: " . $attachment["type"];
		if(isset($attachment["name"]))
		{
			$headers .= "; name=\"{$attachment["name"]}\"";
		}
		$headers .= "\r\n" .
			"Content-Transfer-Encoding: base64\r\n" .
			"\r\n" .
			chunk_split(base64_encode($attachment["content"])) .
			"\r\n";
		return($headers);
	}

	/*
	** Function: mailAttachment
	** Input: STRING to, STRING from, STRING subject,
	** ARRAY attachment
	** Output: none
	** Description: Sends attachments via email. The attachment
	** array is a 2D array. Each element is an associative array
	** containing elements type, name and content.
	*/
	function mailAttachment($to, $from, $subject, $attachment)
	{
		//add from header
		$headers = "From: $from\r\n";

		//specify MIME version 1.0
		$headers .= "MIME-Version: 1.0\r\n";

		//multiple parts require special treatment
		if(count($attachment) > 1)
		{
			//multiple attachments require special handling
			$boundary = uniqid("COREPHP");
			$headers .= "Content-Type: multipart/mixed" .
				"; boundary = $boundary\r\n\r\n" .
				"This is a MIME encoded message.\r\n\r\n" .
				"--$boundary";
			foreach($attachment as $a)
			{
				$headers .= "\r\n" .
				makeAttachment($a) .
				"--$boundary";
			}
			$headers .= "--\r\n";
		}
		else
		{
			$headers .= makeAttachment($attachment[0]);
		}

		//send message
		mail($to, $subject, "", $headers);
	}

	//add text explaining message
	$attach[] = array("content"=>"This is Listing 24-6",
		"type"=>"text/plain");

	//add script to list of attachments
	$fp = fopen(__FILE__, "r");
	$attach[] = array("name"=>basename(__FILE__),
		"content"=>fread($fp, filesize(__FILE__)),
		"type"=>"application/octet-stream");
	fclose($fp);

	//send mail to root
	mailAttachment("root@localhost",
		"httpd@localhost",
		"Listing 24-6",
		$attach);
	print("Mail sent!<br>\n");
?>
</body>
</html>