<?php
	/*
	** Simple class for creating HTML tables
	*/
	class HTMLTable
	{
		static function start($header=FALSE)
		{
			print("<table border=\"1\">\n");
			if(is_array($header))
			{
				print("<tr>\n");
				foreach($header as $h)
				{
					print("<th>" .
						strtoupper($h) .
						"</th>\n");
				}
				print("</tr>\n");
			}
		}

		static function end()
		{
			print("</table>\n\n");
		}

		static function printRow($label, $field)
		{
			print("<tr>\n");

			//label
			if($label !== "")
			{
				print("<th>" .
					strtoupper($label) .
					"</th>\n");
			}

			if(!is_array($field))
			{
				$field = array($field);
			}

			foreach($field as $key=>$value)
			{
				print("<td>");
				if($value === "")
				{
					print("&nbsp;");
				}
				else
				{
					print($value);
				}
				print("</td>\n");
			}
			print("</tr>\n");
		}

		static function printSet($set)
		{
			foreach($set as $field)
			{
				if(isset($field['label']))
				{
					$label = $field['label'];
					unset($field['label']);
				}
				else
				{
					$label = "";
				}

				HTMLTable::printRow($label, $field);
			}
		}
	}
?>
<html>
<head>
	<title>Listing 26-1</title>
</head>
<body>
<p>
This is an example of using a function to repeat
a commonly-used piece of HTML code. It builds
out a table, like this one.
</p>
	<?php
	//show table with labels on the left
	HTMLTable::start();
	HTMLTable::printRow('step 1', 'Start the table');
	HTMLTable::printRow('step 2', 'Print rows');
	HTMLTable::printRow('step 3', 'End the table');
	HTMLTable::end();
?>
<p>
The HTMLTable class allows you to draw all HTML
tables in the same way. To change the look of
all tables, you need only edit the class. Cascading
Style Sheets offer similar technology, but implementing
in PHP means we can make unlimited changes to the
data before building the HTML. It also means we
can neatly indent the data without affecting the
placement on the final document.
</p>
<?php
	//show a table with labels on top
	HTMLTable::start(array('artist', 'song'));
	HTMLTable::printSet(array(
		array('Thelonious Monk', 'Bemsha Swing'),
		array('John Coltrane', 'Spiral'),
		array('Charlie Parker', 'Koko')
	));
	HTMLTable::end();
?>
</body>
</html>