<?php
	/*
	** Get three selectors for month, day, year
	*/
	function getDateSelectors($name, $date=NULL)
	{
		static $monthName = array(1=>"January",
			"February", "March", "April", "May",
			"June", "July", "August", "September",
			"October", "November", "December");

		if($date === NULL)
		{
			$date = time();
		}

		//make Month selector
		$givenMonth = date("m", $date);
		$fields = "<select name=\"{$name}[month]\">\n";
		for($m = 1; $m <= 12; $m++)
		{
			$fields .= "<option value=\"$m\"";
			if($m == $givenMonth)
			{
				$fields .= " selected";
			}
			$fields .= ">" . $monthName[$m] . "</option>\n";
		}
		$fields .= "</select>\n";

		$fields .= "<select name=\"{$name}[day]\">\n";
		$givenDay = date("d", $date);
		for($d=1; $d <= 31; $d++)
		{
			$fields .= "<option value=\"$d\"";
			if($d == $givenDay)
			{
				$fields .= " selected";
			}
			$fields .= ">$d</option>\n";
		}
		$fields .= "</select>\n";
	
		$fields .= "<select name=\"{$name}[year]\">\n";
		$givenYear = date("Y", $date);
		$lastYear = date('Y')+5;
		for($y = date('Y')-5; $y <= $lastYear; $y++)
		{
			$fields .= "<option value=\"$y\"";
			if($y == $givenYear)
			{
				$fields .= " selected";
			}
			$fields .= ">$y</option>\n";
		}
		$fields .= "</select>\n";

		return($fields);
	}

	//start document
	print("<html>\n" .
		"<head>\n" .
		"<title>Listing 26-11</title>\n" .
		"</head>\n");

	//start body
	print("<body>\n");

	//choose default date
	if(isset($_REQUEST['sample']))
	{
		//construct time
		$UseDate = mktime(0, 0, 0,
		$_REQUEST['sample']['month'],
		$_REQUEST['sample']['day'],
		$_REQUEST['sample']['year']);
	}
	else
	{
		//use default
		$UseDate = NULL;
	}

	//make simple form
	print("<form action=\"{$_SERVER['PHP_SELF']}\">\n");
	print(getDateSelectors("sample", $UseDate));
	print("<input type=\"submit\">\n");
	print("</form>\n");

	//close HTML document
	print("</body>\n" .
		"</html>\n");
?>