<?php
	class Factory
	{
		private $registeredClasses = array();
		static private $instance = NULL;
		private function __construct() {}

		static function getInstance()
		{
			if(self::$instance == NULL)
			{
				self::$instance = new Factory();
			}
	
			return self::$instance;
		}

		function registerClass($id, $creator_func)
		{
			$this->registeredClasses[$id] = $creator_func;
		}

		function createObject($id, $args)
		{
			if(!isset($this->registeredClasses[$id]))
			{
				return(NULL);
			}

			return($this->registeredClasses[$id]($args));
		}
	}

	class MyClass
	{
		private $created;

		public function __construct()
		{
			$created = time();
		}

		public function getCreated()
		{
			return($this->created);
		}
	}

	function MyClassCreator()
	{
		return(new MyClass());
	}

	$factory = Factory::getInstance();
	$factory->registerClass(1234, "MyClassCreator");
	$instance = $factory->createObject(1234, array());
?>