<?php
	class mySession
	{
		//prefix with which to mark session files
		var $mark;

		//path for storing session files
		var $path;

		//name of session cookie
		var $name;

		function mySession($mark='mySession_')
		{
			$this->mark = $mark;
		}

		function getFilePath($id)
		{
			return($this->path . '/' . $this->mark . $id);
		}

		function open($path, $name)
		{
			$this->path = $path;
			$this->name = $name;
			return(TRUE);
		}

		function close()
		{
			return(TRUE);
		}
	
		function read($id)
		{
			if($fp = @fopen($this->getFilePath($id), "r"))
			{
				return(fread($fp, filesize($this->getFilePath($id))));
			}
			else
			{
				return("");
			}
		}

		function write($id, $data)
		{
			if($fp = @fopen($this->getFilePath($id), "w"))
			{
				return(fwrite($fp, $data));
			}
			else
			{
				return(FALSE);
			}
		}

		function destroy($id)
		{
			return(@unlink($this->getFilePath($id)));
		}

		function garbage($lifetime)
		{
			$d = dir($this->path);
			while($f = $d->read())
			{
				//file begins with mark and it's too old
				if((strpos($f, $this->mark) == 0) AND
					(time() > (fileatime($f) + $lifetime)))
				{
					unlink("$this->path/$f");
				}
			}

			$d->close();
			return(TRUE);
		}
	}

	$s = new mySession();
	session_set_save_handler(
		array($s, 'open'),
		array($s, 'close'),
		array($s, 'read'),
		array($s, 'write'),
		array($s, 'destroy'),
		array($s, 'garbage')
		);

	//start session
	session_start();

	//initialize a set of session variables
	if(!isset($_SESSION['a']))
	{
		print("Initializing Session<br>");
		$_SESSION['a'] = 'Session Var A';
		$_SESSION['b'] = 123.45;
		$_SESSION['c'] = 0;
	}

	//update session with access count
	$_SESSION['c']++;
	print("Access count: " . $_SESSION['c'] . "<br>");
	print("Session Dump: " . session_encode() . "<br>");
?>