<?php
	class MemoryStream
	{
		var $filename;
		var $filedata;
		var $position;
		function stream_open($path, $mode, $options, &$opened_path)
		{
			//break URL into parts
			$url = parse_url($path);

			//set the file name
			$this->filename = $url["host"];

			//just for kicks we'll set the opened path
			$opened_path = $this->filename;

			//start at zero
			$this->position = 0;

			//copy variable from global scope
			$this->filedata = $GLOBALS['MemoryStream'][$this->filename];

			//open was successful
			return(TRUE);
		}

		function stream_read($count)
		{
			//get data
			$data = substr($this->filedata, $this->position, $count);
	
			//move the pointer forward
			$this->position += strlen($data);
			return($data);
		}
	
		function stream_write($data)
		{
			//start writing at the current position, leaving
			//existing data if it stretches beyond the given data
			$this->filedata =
				substr($this->filedata, 0, $this->position) .
				$data .
				substr($this->filedata, $this->position + strlen($data));
			$this->position += strlen($data);
	
			return(strlen($data));
		}
	
		function stream_tell()
		{
			return($this->position);
		}
	
		function stream_eof()
		{
			return($this->position >= strlen($this->filedata));
		}
	
		function stream_flush()
		{
			//copy the entire set of data over
			//what's there globally
			$GLOBALS['MemoryStream'][$this->filename] =
			$this->filedata;
	
			return(TRUE);
		}
	
		function stream_close()
		{
			$this->stream_flush();
			return(TRUE);
		}
	
		function stream_seek($offset, $from)
		{
			switch($from)
			{
				case SEEK_SET:
					$position = $offset;
					break;
				case SEEK_CUR:
					$position += $offset;
					break;
				case SEEK_END:
					$position = strlen($this->filedata) + $offset;
					break;
				default:
					return false;
			}
	
			//check for impossible positions
			if(($position < 0) OR ($position >= strlen($this->filedata)))
			{
				return(FALSE);
			}
	
			$this->position = $position;
			return(TRUE);
		}
	}

	$GLOBALS['MemoryStream']['test.txt'] = 'test test test test';

	//register the new RAM Disk wrapper
	if(!stream_register_wrapper('ram', 'MemoryStream'))
	{
		print('Could not register RAM Disk wrapper.');
		exit;
	}

	//open file in RAM disk
	if(!($fp = fopen('ram://test.txt', 'r+')))
	{
		print('Could not open file.');
		exit;
	}

	//write three lines
	fwrite($fp, "test 1\n");
	fwrite($fp, "test 2\n");
	fwrite($fp, "test 3\n");

	//move pointer back to beginning
	rewind($fp);

	//read the contents
	while(!feof($fp))
	{
		print(fgets($fp) . '<br>');
	}

	//close
	fclose($fp);
?>