<?php
	//Call function if it's available
	function callIfPossible($f, $arg=FALSE)
	{
		//if no arguments, use empty array
		if($arg === FALSE)
		{
			$arg = array();
		}

		if(is_callable($f, FALSE, $callName))
		{
			call_user_func_array($f, $arg);
		}
		else
		{
			print("Unable to call $callName<br>");
		}
	}

	//functions for testing
	function a()
	{
		print('function a<br>');
	}

	class c
	{
		function m()
		{
			print('method m<br>');
		}
	}

	//built-in function
	callIfPossible('print_r', array('print_r<br>'));

	//not technically a function
	callIfPossible('print', array('print<br>'));

	//user function
	callIfPossible('a');

	//non-existent
	callIfPossible('b');

	//method from a class
	callIfPossible(array('c', 'm'));

	//non-existent
	callIfPossible(array('d', 'm'));

	//method from an object
	$C = new c;
	callIfPossible(array($C, 'm'));

	//non-existent
	callIfPossible(array($C, 'x'));
?>